reSIProcate
SIP stack, Dialog Usage Manager and related libraries
Loading...
Searching...
No Matches
resip::Token Class Reference

Represents the "token" element in the RFC 3261 grammar. More...

#include <Token.hxx>

Inheritance diagram for resip::Token:
[legend]

Public Member Functions

 Token ()
 
 Token (const Data &d)
 
 Token (const HeaderFieldValue &hfv, Headers::Type type, PoolBase *pool=0)
 
 Token (const Token &orig, PoolBase *pool=0)
 
Token & operator= (const Token &)
 
bool isEqual (const Token &rhs) const
 
bool operator== (const Token &rhs) const
 
bool operator!= (const Token &rhs) const
 
bool operator< (const Token &rhs) const
 
const Data & value () const
 Gets the value (ie; no parameters) of this Token as a Data&.
 
Data & value ()
 
virtual void parse (ParseBuffer &pb)
 
virtual ParserCategory * clone () const
 
virtual ParserCategory * clone (void *location) const
 
virtual ParserCategory * clone (PoolBase *pool) const
 
virtual EncodeStream & encodeParsed (EncodeStream &str) const
 
virtual Parameter * createParam (ParameterTypes::Type type, ParseBuffer &pb, const std::bitset< 256 > &terminators, PoolBase *pool)
 
bool exists (const Param< Token > &paramType) const
 
void remove (const Param< Token > &paramType)
 
 defineParam (text, "text", ExistsOrDataParameter, "RFC 3840")
 
 defineParam (cause, "cause", UInt32Parameter, "RFC 3326")
 
 defineParam (dAlg, "d-alg", DataParameter, "RFC 3329")
 
 defineParam (dQop, "d-qop", DataParameter, "RFC 3329")
 
 defineParam (dVer, "d-ver", QuotedDataParameter, "RFC 3329")
 
 defineParam (expires, "expires", UInt32Parameter, "RFC 3261")
 
 defineParam (filename, "filename", DataParameter, "RFC 2183")
 
 defineParam (fromTag, "from-tag", DataParameter, "RFC 4235")
 
 defineParam (handling, "handling", DataParameter, "RFC 3261")
 
 defineParam (id, "id", DataParameter, "RFC 3265")
 
 defineParam (q, "q", QValueParameter, "RFC 3261")
 
 defineParam (reason, "reason", DataParameter, "RFC 3265")
 
 defineParam (retryAfter, "retry-after", UInt32Parameter, "RFC 3265")
 
 defineParam (toTag, "to-tag", DataParameter, "RFC 4235")
 
 defineParam (extension, "ext", DataParameter, "RFC 3966")
 
 defineParam (profileType, "profile-type", DataParameter, "RFC 6080")
 
 defineParam (vendor, "vendor", QuotedDataParameter, "RFC 6080")
 
 defineParam (model, "model", QuotedDataParameter, "RFC 6080")
 
 defineParam (version, "version", QuotedDataParameter, "RFC 6080")
 
 defineParam (effectiveBy, "effective-by", UInt32Parameter, "RFC 6080")
 
 defineParam (document, "document", DataParameter, "draft-ietf-sipping-config-framework-07 (removed in 08)")
 
 defineParam (appId, "app-id", DataParameter, "draft-ietf-sipping-config-framework-05 (renamed to auid in 06, which was then removed in 08)")
 
 defineParam (networkUser, "network-user", DataParameter, "draft-ietf-sipping-config-framework-11 (removed in 12)")
 
 defineParam (require, "require", ExistsParameter, "RFC 5373")
 
 defineParam (utranCellId3gpp, "utran-cell-id-3gpp", DataParameter, "RFC 3455")
 
 defineParam (cgi3gpp, "cgi-3gpp", DataParameter, "RFC 3455")
 
 defineParam (ccf, "ccf", DataParameter, "RFC 3455")
 
 defineParam (ecf, "ecf", DataParameter, "RFC 3455")
 
 defineParam (icidValue, "icid-value", DataParameter, "RFC 3455")
 
 defineParam (icidGeneratedAt, "icid-generated-at", DataParameter, "RFC 3455")
 
 defineParam (origIoi, "orig-ioi", DataParameter, "RFC 3455")
 
 defineParam (termIoi, "term-ioi", DataParameter, "RFC 3455")
 
bool exists (const ParamBase &paramType) const
 Checks for the existence of a natively supported parameter.
 
bool exists (const ExtensionParameter &param) const
 Checks for the existence of a non-natively-supported parameter.
 
void remove (const ParamBase &paramType)
 Removes a natively supported parameter, if the parameter is present.
 
void remove (const ExtensionParameter &param)
 Removes a non-natively-supported parameter, if the parameter is present.
 
const Data & param (const ExtensionParameter &param) const
 Const accessor for non-natively-supported parameter types.
 
Data & param (const ExtensionParameter &param)
 Accessor for non-natively-supported parameter types.
 
- Public Member Functions inherited from resip::ParserCategory
 ParserCategory (const HeaderFieldValue &headerFieldValue, Headers::Type type, PoolBase *pool=0)
 
 ParserCategory (const char *buf, int length, Headers::Type type, PoolBase *pool=0)
 
 ParserCategory (const ParserCategory &rhs, PoolBase *pool=0)
 
ParserCategory & operator= (const ParserCategory &rhs)
 
virtual ~ParserCategory ()
 
bool exists (const ParamBase &paramType) const
 Checks for the existence of a natively supported parameter.
 
void remove (const ParamBase &paramType)
 Removes a natively supported parameter, if the parameter is present.
 
const Data & param (const ExtensionParameter &param) const
 Const accessor for non-natively-supported parameter types.
 
Data & param (const ExtensionParameter &param)
 Accessor for non-natively-supported parameter types.
 
void remove (const ExtensionParameter &param)
 Removes a non-natively-supported parameter, if the parameter is present.
 
bool exists (const ExtensionParameter &param) const
 Checks for the existence of a non-natively-supported parameter.
 
void removeParametersExcept (const ParameterTypeSet &set=EmptyParameterTypeSet)
 Removes all known parameters except those that are specified in set.
 
void clearUnknownParameters ()
 
void parseParameters (ParseBuffer &pb)
 
EncodeStream & encodeParameters (EncodeStream &str) const
 Encodes parameters as they should appear on the wire.
 
Data commutativeParameterHash () const
 
Parameter * getParameterByEnum (ParameterTypes::Type type) const
 
void removeParameterByEnum (ParameterTypes::Type type)
 
void setParameter (const Parameter *parameter)
 
int numKnownParams () const
 Returns the number of known (natively supported) parameters.
 
int numUnknownParams () const
 Returns the number of unknown parameters.
 
- Public Member Functions inherited from resip::LazyParser
 LazyParser (const HeaderFieldValue &headerFieldValue)
 
 LazyParser (const char *buf, int length)
 
 LazyParser (const HeaderFieldValue &headerFieldValue, HeaderFieldValue::CopyPaddingEnum e)
 
 LazyParser (const LazyParser &rhs)
 
 LazyParser (const LazyParser &rhs, HeaderFieldValue::CopyPaddingEnum e)
 
LazyParser & operator= (const LazyParser &rhs)
 
virtual ~LazyParser ()
 
EncodeStream & encode (EncodeStream &str) const
 Encodes this element to a stream, in the fashion it should be represented on the wire.
 
bool isParsed () const
 Returns true iff a parse has been attempted.
 
HeaderFieldValue & getHeaderField ()
 
void checkParsed () const
 
void checkParsed ()
 
void doParse () const
 
void markDirty () const
 
bool isWellFormed () const
 Returns true iff this element was parsed successfully, according to the implementation of parse().
 

Static Public Attributes

static constexpr CommaHandlingMode commaHandling = CommasAllowedOutputCommas
 
- Static Public Attributes inherited from resip::ParserCategory
static const ParameterTypeSet EmptyParameterTypeSet
 

Additional Inherited Members

- Public Types inherited from resip::ParserCategory
enum  { UnknownParserCategory = -1 }
 
enum  CommaHandlingMode { NoCommaTokenizing = 0 , CommasAllowedOutputMulti = 1 , CommasAllowedOutputCommas = 3 }
 
typedef std::set< ParameterTypes::Type > ParameterTypeSet
 
- Protected Types inherited from resip::ParserCategory
typedef std::vector< Parameter *, StlPoolAllocator< Parameter *, PoolBase > > ParameterList
 
- Protected Member Functions inherited from resip::ParserCategory
 ParserCategory (PoolBase *pool=0)
 
bool addParameter (Parameter *param)
 
bool addParameter (UnknownParameter *unknownParam)
 
Parameter * getParameterByData (const Data &data) const
 
void removeParameterByData (const Data &data)
 
PoolBase * getPool ()
 
void freeParameter (Parameter *p)
 
virtual const Data & errorContext () const
 
- Protected Member Functions inherited from resip::LazyParser
 LazyParser ()
 
void clear ()
 
- Protected Attributes inherited from resip::ParserCategory
ParameterList mParameters
 
ParameterList mUnknownParameters
 
PoolBase * mPool
 
Headers::Type mHeaderType
 

Detailed Description

Represents the "token" element in the RFC 3261 grammar.

Definition at line 17 of file Token.hxx.

Constructor & Destructor Documentation

◆ Token() [1/4]

Token::Token ( )

Definition at line 21 of file Token.cxx.

◆ Token() [2/4]

Token::Token ( const Data &  d)
explicit

Definition at line 26 of file Token.cxx.

◆ Token() [3/4]

Token::Token ( const HeaderFieldValue &  hfv,
Headers::Type  type,
PoolBase *  pool = 0 
)

Definition at line 31 of file Token.cxx.

◆ Token() [4/4]

Token::Token ( const Token &  orig,
PoolBase *  pool = 0 
)

Definition at line 36 of file Token.cxx.

Member Function Documentation

◆ clone() [1/3]

ParserCategory * Token::clone ( ) const
virtual

Implements resip::ParserCategory.

Definition at line 101 of file Token.cxx.

◆ clone() [2/3]

ParserCategory * Token::clone ( PoolBase *  pool) const
virtual

Implements resip::ParserCategory.

Definition at line 113 of file Token.cxx.

◆ clone() [3/3]

ParserCategory * Token::clone ( void *  location) const
virtual

Implements resip::ParserCategory.

Definition at line 107 of file Token.cxx.

◆ createParam()

Parameter * Token::createParam ( ParameterTypes::Type  type,
ParseBuffer &  pb,
const std::bitset< 256 > &  terminators,
PoolBase *  pool 
)
virtual

Reimplemented from resip::ParserCategory.

Definition at line 129 of file Token.cxx.

◆ defineParam() [1/32]

resip::Token::defineParam ( appId  ,
"app-id"  ,
DataParameter  ,
"draft-ietf-sipping-config-framework-05 (renamed to auid in 06, which was then removed in 08)"   
)

◆ defineParam() [2/32]

resip::Token::defineParam ( cause  ,
"cause"  ,
UInt32Parameter  ,
"RFC 3326"   
)

◆ defineParam() [3/32]

resip::Token::defineParam ( ccf  ,
"ccf"  ,
DataParameter  ,
"RFC 3455"   
)

◆ defineParam() [4/32]

resip::Token::defineParam ( cgi3gpp  ,
"cgi-3gpp"  ,
DataParameter  ,
"RFC 3455"   
)

◆ defineParam() [5/32]

resip::Token::defineParam ( dAlg  ,
"d-alg"  ,
DataParameter  ,
"RFC 3329"   
)

◆ defineParam() [6/32]

resip::Token::defineParam ( document  ,
"document"  ,
DataParameter  ,
"draft-ietf-sipping-config-framework-07 (removed in 08)"   
)

◆ defineParam() [7/32]

resip::Token::defineParam ( dQop  ,
"d-qop"  ,
DataParameter  ,
"RFC 3329"   
)

◆ defineParam() [8/32]

resip::Token::defineParam ( dVer  ,
"d-ver"  ,
QuotedDataParameter  ,
"RFC 3329"   
)

◆ defineParam() [9/32]

resip::Token::defineParam ( ecf  ,
"ecf"  ,
DataParameter  ,
"RFC 3455"   
)

◆ defineParam() [10/32]

resip::Token::defineParam ( effectiveBy  ,
"effective-by"  ,
UInt32Parameter  ,
"RFC 6080"   
)

◆ defineParam() [11/32]

resip::Token::defineParam ( expires  ,
"expires"  ,
UInt32Parameter  ,
"RFC 3261"   
)

◆ defineParam() [12/32]

resip::Token::defineParam ( extension  ,
"ext"  ,
DataParameter  ,
"RFC 3966"   
)

◆ defineParam() [13/32]

resip::Token::defineParam ( filename  ,
"filename"  ,
DataParameter  ,
"RFC 2183"   
)

◆ defineParam() [14/32]

resip::Token::defineParam ( fromTag  ,
"from-tag"  ,
DataParameter  ,
"RFC 4235"   
)

◆ defineParam() [15/32]

resip::Token::defineParam ( handling  ,
"handling"  ,
DataParameter  ,
"RFC 3261"   
)

◆ defineParam() [16/32]

resip::Token::defineParam ( icidGeneratedAt  ,
"icid-generated-at"  ,
DataParameter  ,
"RFC 3455"   
)

◆ defineParam() [17/32]

resip::Token::defineParam ( icidValue  ,
"icid-value"  ,
DataParameter  ,
"RFC 3455"   
)

◆ defineParam() [18/32]

resip::Token::defineParam ( id  ,
"id"  ,
DataParameter  ,
"RFC 3265"   
)

◆ defineParam() [19/32]

resip::Token::defineParam ( model  ,
"model"  ,
QuotedDataParameter  ,
"RFC 6080"   
)

◆ defineParam() [20/32]

resip::Token::defineParam ( networkUser  ,
"network-user"  ,
DataParameter  ,
"draft-ietf-sipping-config-framework-11 (removed in 12)"   
)

◆ defineParam() [21/32]

resip::Token::defineParam ( origIoi  ,
"orig-ioi"  ,
DataParameter  ,
"RFC 3455"   
)

◆ defineParam() [22/32]

resip::Token::defineParam ( profileType  ,
"profile-type"  ,
DataParameter  ,
"RFC 6080"   
)

◆ defineParam() [23/32]

resip::Token::defineParam ( q  ,
"q"  ,
QValueParameter  ,
"RFC 3261"   
)

◆ defineParam() [24/32]

resip::Token::defineParam ( reason  ,
"reason"  ,
DataParameter  ,
"RFC 3265"   
)

◆ defineParam() [25/32]

resip::Token::defineParam ( require  ,
"require"  ,
ExistsParameter  ,
"RFC 5373"   
)

◆ defineParam() [26/32]

resip::Token::defineParam ( retryAfter  ,
"retry-after"  ,
UInt32Parameter  ,
"RFC 3265"   
)

◆ defineParam() [27/32]

resip::Token::defineParam ( termIoi  ,
"term-ioi"  ,
DataParameter  ,
"RFC 3455"   
)

◆ defineParam() [28/32]

resip::Token::defineParam ( text  ,
"text"  ,
ExistsOrDataParameter  ,
"RFC 3840"   
)

◆ defineParam() [29/32]

resip::Token::defineParam ( toTag  ,
"to-tag"  ,
DataParameter  ,
"RFC 4235"   
)

◆ defineParam() [30/32]

resip::Token::defineParam ( utranCellId3gpp  ,
"utran-cell-id-3gpp"  ,
DataParameter  ,
"RFC 3455"   
)

◆ defineParam() [31/32]

resip::Token::defineParam ( vendor  ,
"vendor"  ,
QuotedDataParameter  ,
"RFC 6080"   
)

◆ defineParam() [32/32]

resip::Token::defineParam ( version  ,
"version"  ,
QuotedDataParameter  ,
"RFC 6080"   
)

◆ encodeParsed()

EncodeStream & Token::encodeParsed ( EncodeStream &  str) const
virtual

Implements resip::LazyParser.

Definition at line 119 of file Token.cxx.

◆ exists() [1/3]

bool ParserCategory::exists ( const ExtensionParameter &  param) const

Checks for the existence of a non-natively-supported parameter.

Parameters
paramThe runtime constructed accessor token.
Returns
true iff the parameter is present.

Definition at line 187 of file ParserCategory.cxx.

◆ exists() [2/3]

bool Token::exists ( const Param< Token > &  paramType) const

Definition at line 139 of file Token.cxx.

◆ exists() [3/3]

bool resip::ParserCategory::exists ( const ParamBase &  paramType) const
inline

Checks for the existence of a natively supported parameter.

Parameters
paramTypeThe accessor token for the parameter.
Returns
true iff the parameter is present.

Definition at line 145 of file ParserCategory.hxx.

◆ isEqual()

bool Token::isEqual ( const Token &  rhs) const

Definition at line 53 of file Token.cxx.

◆ operator!=()

bool Token::operator!= ( const Token &  rhs) const

Definition at line 65 of file Token.cxx.

◆ operator<()

bool Token::operator< ( const Token &  rhs) const

Definition at line 70 of file Token.cxx.

◆ operator=()

Token & Token::operator= ( const Token &  rhs)

Definition at line 42 of file Token.cxx.

◆ operator==()

bool Token::operator== ( const Token &  rhs) const

Definition at line 59 of file Token.cxx.

◆ param() [1/2]

Data & ParserCategory::param ( const ExtensionParameter &  param)

Accessor for non-natively-supported parameter types.

Will create the parameter if it does not exist.

Parameters
paramThe runtime constructed parameter accessor.
Returns
The parameter, as a raw Data.

Definition at line 173 of file ParserCategory.cxx.

◆ param() [2/2]

const Data & ParserCategory::param ( const ExtensionParameter &  param) const

Const accessor for non-natively-supported parameter types.

Exceptions
ParserCategory::Exceptionif this parameter doesn't exist.
Parameters
paramThe runtime constructed parameter accessor.
Returns
The parameter, as a raw Data.

Definition at line 165 of file ParserCategory.cxx.

◆ parse()

void Token::parse ( ParseBuffer &  pb)
virtual

Implements resip::LazyParser.

Definition at line 91 of file Token.cxx.

◆ remove() [1/3]

void ParserCategory::remove ( const ExtensionParameter &  param)

Removes a non-natively-supported parameter, if the parameter is present.

Parameters
paramThe accessor token for the parameter.

Definition at line 180 of file ParserCategory.cxx.

◆ remove() [2/3]

void Token::remove ( const Param< Token > &  paramType)

Definition at line 147 of file Token.cxx.

◆ remove() [3/3]

void ParserCategory::remove ( const ParamBase &  paramType)

Removes a natively supported parameter, if the parameter is present.

Parameters
paramTypeThe accessor token for the parameter.

Definition at line 156 of file ParserCategory.cxx.

◆ value() [1/2]

Data & Token::value ( )

Definition at line 84 of file Token.cxx.

◆ value() [2/2]

const Data & Token::value ( ) const

Gets the value (ie; no parameters) of this Token as a Data&.

Definition at line 77 of file Token.cxx.

Member Data Documentation

◆ commaHandling

constexpr CommaHandlingMode resip::Token::commaHandling = CommasAllowedOutputCommas
staticconstexpr

Definition at line 20 of file Token.hxx.


The documentation for this class was generated from the following files: